//import libraries. 
import de.bezier.data.sql.*;
import arb.soundcipher.*;
import twitter4j.*;
import toxi.geom.*;

// SoundCipher
SoundCipher sc;

// MySQL
MySQL msql;

// data containers
String[] keywords = {"facebook", "twitter", "linkedin"};
ArrayList<ArrayList> mArray = new ArrayList<ArrayList>();
ArrayList<ArrayList> dArray = new ArrayList<ArrayList>();
int[] totalCount = {0, 0, 0};
int[] annualCount = {0, 0, 0, 0, 0, 0};
int[] monthlyCount = new int[72];
String[] wd = {"","","","","","","","","",""};

//Build an ArrayList to hold all of the words that we get from the imported tweets
ArrayList<String> words = new ArrayList();

// color palette

//color[] palette1 = {#CE5F28, #CE9728, #CECE28, #FF0000};
//color[] palette2 = {#302D40, #475956, #90A67B, #FF0000}; // space
//color[] palette3 = {#021859, #0433BF, #0460D9, #05F2F5, #010A26}; // moonlight
//color[] palette4 = {#375C8C, #B8B0A1, #96E1FE, #FDFEE0, #8C6B42};
//color[] palette5 = {#FF0000, #FF7400, #CD0074, #A60000};
//color[] palette6 = {#03899C, #FF9C00, #FF4900, #015965};
//color[] palette7 = {#3b5998, #8b9dc3, #f7f7f7, #dfe3ee}; // facebook
//color[] palette8 = {#cceaf3, #c0deed, #33CCFF, #0084b4}; // twitter
//color[] palette9 = {#33CCFF, #3B5998, #4875B4, #0084b4}; // linkedin

color[] palette0 = {#F2D03B, #47D9BF, #00A1D9, #04518C, #003056}; // bahamas
color[] palette1 = {#A3C46D, #8E9962, #703B35, #472528, #242126}; // venture capitalist
color[] palette2 = {#E9F29D, #B7C29D, #878E8F, #67617A, #51456B};
color[] palette3 = {#027373, #038C7F, #D9B343, #F28C3A, #BF3F34};
color[] palette4 = {#E82C0C, #F0840C, #E5B600, #4F00FF, #DE0001};
color[] palette5 = {#072111, #20421B, #AD8F15, #FF0011, #EB7500};
color[] palette6 = {#FFB700, #E58D00, #BF7560, #7F5370, #402768};
color[] palette7 = {#F33645, #F28907, #F2CB05, #1AC6D9, #9265A6};
color[] palette8 = {#39060A, #85000C, #928E0F, #083952, #0A8ED2};
color[] palette9 = {#F26B00, #D92800, #00010D, #8C030E, #590212};

color[] palette = palette0;

// fonts
PFont font0, font1;

// spacing variables
float diameter = height/3;
int barWidth = 14;
int barHeight = 100;
int xInterval = 5;
int yInterval = 30;
int topBorder = 50;
int leftBorder = 20;
int yAxis;
int yPos; // yAxis + 10

// switches
boolean grid = true;
boolean showTweets = true;
boolean dayViz = false;
int number = 0;

// bool
int pointer = -1;

void setup() {
  // canvas setup
  size(900, 900); //size of the sketch window
  colorMode(HSB, 360, 100, 100);
  textAlign(LEFT, CENTER); // (horizontal,vertical)
  smooth();

  font0 = loadFont("AcknowledgeTTBRK-36.vlw");
  font1 = loadFont("Manteka-100.vlw");
  textFont(font0, 20);
  
  // soundcipher
  sc = new SoundCipher(this);
  sc.tempo(5);
  sc.repeat(0);
  
  // connecting to the database
  msql = new MySQL( this, "tango.mat.ucsb.edu:3306", "spl1", "mat259", "V1sual1zat1on" ); //host, database, user, password
  
  while(msql.connect()==false){delay(1000);}
  if ( msql.connect() )
  {
    for (int kw = 0; kw < 3; kw++){
      
      // create data containers
      ArrayList tArray = new ArrayList();
      HashMap hmap = new HashMap();
      
      String query = "SELECT count(*), DATE_FORMAT(o,'%Y-%m') as coutmonth, SUBSTRING(dewey,1,1) as dw FROM title, activity, dewey WHERE title.bib = activity.bib AND activity.bib = dewey.bib AND LOWER(title) like '%"
      + keywords[kw] 
      + "%' AND (SUBSTR(dewey,1,1) = '6' OR SUBSTR(dewey,1,1) = '0' OR SUBSTR(dewey,1,1) = '3') AND year(o) > 2006 AND year(o) < 2013 GROUP BY coutmonth, dw;";
      println(query);
      msql.query(query);
      msql.next();
  
      int count = 0;
      while ( msql.next () ) {
        String[] temp = split(msql.getString(2), '-');
        String value;
        value = temp[0] + "-" + int(temp[1]) + "-" + msql.getInt(3);
  
        // insert each result into a hashmap      
        hmap.put(value, new Integer(msql.getInt(1)));
        totalCount[kw] += msql.getInt(1);
        count++;
      }
      
      // store each item into an ArrayList
      for (int i = 2007; i < 2013; i++) {
        int annualSum = 0;
        for (int j = 1; j < 13; j++) {
          int[] cnt = {
            0, 0, 0
          };
          for (int k = 0; k < 3; k++) {
            String label = i + "-" + j + "-" + k*3;
            Integer n = (Integer)hmap.get(label);
            cnt[k] = (n!=null ? n : 0);
            annualSum += cnt[k];
          }
          tArray.add(new Entity(i + "-" + j, i, j, cnt[0], cnt[1], cnt[2]));
        }
        annualCount[i-2007] = annualSum;
      }
      mArray.add(new ArrayList(tArray));
      int sz = tArray.size();
      
      // compute coordinates on canvas
      for (int i = 0; i < sz; i++) { 

        // An ArrayList doesn't know what it is storing so we have to CAST the object coming out
        Entity t = (Entity) mArray.get(kw).get(i);
        
        // computing coordinates for the items to visualize
        t.xPosition = leftBorder + barWidth*i + xInterval; // bar width = 20px, 5px for interval
        t.yPosition = topBorder + barHeight*kw + yInterval; // bar height = 50px, 20px for interval
        
//        println(t.xPosition+","+t.yPosition+"::"+t.count0+":"+t.count3+":"+t.count6);
      }
      tArray.clear();
      hmap.clear();
    }
  }
  
  // Twitter4j
  //Credentials
  ConfigurationBuilder cb = new ConfigurationBuilder();
  cb.setOAuthConsumerKey("F8vfEawlvZLzVe0iN3ys0Q");
  cb.setOAuthConsumerSecret("rKySBRoCvzYMde9FAyEiTcnlULYMH4pezREAXoWic");
  cb.setOAuthAccessToken("64969508-wPGqmNAcd7OmS1CopvwMylG0ftcljC6aOrIRNgpt8");
  cb.setOAuthAccessTokenSecret("2pJycfMYlwSODB1U2Rz7PxwqIw2ibyizTkrWzP5us");
  
  //Make the twitter object and prepare the query
  Twitter twitter = new TwitterFactory(cb.build()).getInstance();
  
  // Twitter query
  Query query = new Query("@SPLBuzz");
  query.count(100); // results per page
  
  // Try making the query request.
  try {
    QueryResult result = twitter.search(query);
    ArrayList tweets = (ArrayList) result.getTweets();
 
    for (int i = 0; i < tweets.size(); i++) {
      Status t = (Status) tweets.get(i);
      User u = t.getUser();
      String user = u.getName();
      String msg = t.getText();
      Date d = t.getCreatedAt();
//      println("Tweet by " + user + " at " + d + ": " + msg);
      
      //Break the tweet into words
      String[] input = msg.split(" ");
      for (int j = 0;  j < input.length; j++) {
        //Put each word into the words ArrayList
        words.add(input[j]);
      }
    };
  }
  catch (TwitterException te) {
    println("Couldn't connect: " + te);
  };
}

void draw() {
  background(#FFFFFF);
  textAlign(CENTER, CENTER);
  noStroke();  

  // Title
  textFont(font0, 30);
  fill(#222222);
  text("Monthly Check-out Distribution of Social Media Books", width/2, 20);
  textFont(font0, 18);
  fill(#6C6C6C);
  text("Source: Seattle Public Library  |  Byungkyu (Jay) Kang, January, 2013", width/2, 35);

  // initialize vars
  float xPrev = 0;
  float yPrev = 0;
  
  // outer ring
  number = 0;
  for (int i = 0; i < 72; i++){
    Entity t0 = (Entity) mArray.get(0).get(i);
    Entity t1 = (Entity) mArray.get(1).get(i);
    Entity t2 = (Entity) mArray.get(2).get(i);
    int arc0 = t0.count0 + t0.count3 + t0.count6;
    int arc1 = t1.count0 + t1.count3 + t1.count6;
    int arc2 = t2.count0 + t2.count3 + t2.count6;
    int layer1 = arc0;
    int layer2 = arc0 + arc1;
    int layer3 = arc0 + arc1 + arc2;
    
    noStroke();
    fill(palette[2]); // linkedin
    arc(width/2, height/2, 400+layer3, 400+layer3, radians(60*(t0.y-2007)+(t0.m-1)*5), radians(60*(t0.y-2007)+t0.m*5));
    fill(palette[1]); // twitter
    arc(width/2, height/2, 400+layer2, 400+layer2, radians(60*(t0.y-2007)+(t0.m-1)*5), radians(60*(t0.y-2007)+t0.m*5));
    fill(palette[0]); // facebook
    arc(width/2, height/2, 400+layer1, 400+layer1, radians(60*(t0.y-2007)+(t0.m-1)*5), radians(60*(t0.y-2007)+t0.m*5));
        
    // using lib
    Polygon2D poly=new Polygon2D();
    // add corner points of quad
    poly.add(new Vec2D(width/2 + 200*cos(radians(60*(t0.y-2007)+(t0.m-1)*5)),  height/2 + 200*sin(radians(60*(t0.y-2007)+(t0.m-1)*5))));
    poly.add(new Vec2D(width/2 + 200*cos(radians(60*(t0.y-2007)+(t0.m)*5)),  height/2 + 200*sin(radians(60*(t0.y-2007)+(t0.m)*5))));
    poly.add(new Vec2D(width/2 + (200+layer3)*cos(radians(60*(t0.y-2007)+(t0.m)*5)),  height/2 + (200+layer3)*sin(radians(60*(t0.y-2007)+(t0.m)*5))));
    poly.add(new Vec2D(width/2 + (200+layer3)*cos(radians(60*(t0.y-2007)+(t0.m-1)*5)),  height/2 + (200+layer3)*sin(radians(60*(t0.y-2007)+(t0.m-1)*5))));
    
    // check if mouse pos is inside
    if (poly.containsPoint(new Vec2D(mouseX,mouseY))) {
      number = layer3;
    }
    
    // store monthlyCount
    monthlyCount[i] = layer3;
  }
  
  // painting main circle
  for (int j = 0; j < 6; j++){
    fill(#EEEEEE);
    stroke(#DDDDDD);
//    stroke(#5A5A5A);
    arc(width/2, height/2, 400, 400, radians(60*j), radians(60*(j+1)));
    if (grid){
      line((width/2+400*cos(radians(60*j))), (height/2+400*sin(radians(60*j))), width/2, height/2);
    }
  }
  
  // grids for each month
  if (grid){
    for (int i = 0; i < 72; i++){
      stroke(#BBBBBB);
      line((width/2+200*cos(radians(5*i))), (height/2+200*sin(radians(5*i))), width/2, height/2);
    }
  
  // base line for the frequency waves
    noFill();
    stroke(#000000, 50);
    strokeWeight(1);
    arc(width/2, height/2, 200, 200, 0, TWO_PI);
  }
  
  // drawing tree rings
  strokeCap(SQUARE);
  for (int kw = 0; kw < 3; kw++){
    
    int xpre = width/2 + 100;
    int ypre = height/2 + 0;
    
    // daily frequency
    if (dayViz){
      for (int i=0; i<dArray.get(kw).size(); i++) {
        EntityDay t = (EntityDay) dArray.get(kw).get(i);
        
        stroke(palette[kw]);
        
        float angle = radians(60*(i/372.0));
        int xpos = int(width/2 + 100*cos(angle) + 5*t.count*cos(angle));
        int ypos = int(height/2 + 100*sin(angle) + 5*t.count*sin(angle));
        line(xpre, ypre, xpos, ypos);
        xpre = xpos;
        ypre = ypos;
      }
    // monthly frequency
    }else{
      for (int i=0; i<mArray.get(kw).size(); i++) {
        Entity t = (Entity) mArray.get(kw).get(i);
        
        int h1 = t.count0;
        int h2 = t.count0 + t.count3;
        int h3 = t.count0 + t.count3 + t.count6;
        
        stroke(palette[kw]);
        
        float angle = radians(60*(i/12.0));
        int xpos = int(width/2 + 100*cos(angle) + 0.7*h3*cos(angle));
        int ypos = int(height/2 + 100*sin(angle) + 0.7*h3*sin(angle));
        line(xpre, ypre, xpos, ypos);
        xpre = xpos;
        ypre = ypos;
      }
    }
  }
  
  for (int j = 0; j < 6; j++){
    // painting alpha arcs (annual frequency)
    stroke(#DDDDDD);
    fill(palette[3], annualCount[j]/4.1);
    arc(width/2, height/2, annualCount[j]/2, annualCount[j]/2, radians(60*j), radians(60*(j+1)));
//    println(annualCount);
    
    // print labels (years)
    pushStyle();
    textFont(font0, 36);
    textAlign(CENTER, CENTER);
    fill(#000000, 50);
    text(2007+j, (width/2+350*cos(radians(60*j+30))), (height/2+350*sin(radians(60*j+30))));
    popStyle();
    
  }
  
  // legend label
  noStroke(); // three color boxes
  fill(palette[0]);
  rect(leftBorder, 140 - 3*barWidth, 0.7*barWidth, 0.7*barWidth);
  fill(palette[1]);
  rect(leftBorder, 140 - 2*barWidth, 0.7*barWidth, 0.7*barWidth);
  fill(palette[2]);
  rect(leftBorder, 140 - 1*barWidth, 0.7*barWidth, 0.7*barWidth);
  
  fill(#6C6C6C); // text labels
  textAlign(LEFT, CENTER);
  text("Number of Check-outs", leftBorder + barWidth, 140 - 4*barWidth);
  text("Facebook : " + totalCount[0], leftBorder + barWidth, 140 - 3*barWidth);
  text("Twitter : " + totalCount[1], leftBorder + barWidth, 140 - 2*barWidth);
  text("LinkedIn : " + totalCount[2], leftBorder + barWidth, 140 - 1*barWidth);
  
  //Draw a word from the list of words that we've built
  if (frameCount < 20 || frameCount % 200 == 0){
    for (int i = 0; i<10; i++){
//      int j = (frameCount % (words.size()-i));
//      wd[i] = words.get(j);
      wd[i] = words.get(int(random(0,words.size())));
    }
  }
  
//  String word = words.get(i);
  
  //Put it somewhere random on the stage, with a random size and colour
  if (showTweets){
    pushStyle();
    fill(#33CCFF);
    text("Words from Tweets on @SPLBuzz", leftBorder + barWidth, 180 - 14);
    textSize(15);
    fill(#000000);
    for (int i = 0; i<10; i++){
      text(wd[i], leftBorder + barWidth, 180 + i*barWidth);
    }
    popStyle();
  }
  text("Key Triggers", leftBorder + barWidth, height - 42);
  text("[g] grids on/off | [t] tweets on/off | [d] daily frequency on/off", leftBorder + barWidth, height - 28);
  text("[0-9] Different Colour Schemes", leftBorder + barWidth, height - 14);
  
  if (number > 0){
    textFont(font1, 100);
    fill(#FF0000, 90); // text labels
    textAlign(CENTER, CENTER);
    text(number, width/2, height/2);
  }
}

void keyPressed(){
  // palette toggle
  if ( key == '0' ){
    palette = palette0;
  }
  if ( key == '1' ){
    palette = palette1;
  }
  if ( key == '2' ){
    palette = palette2;
  }
  if ( key == '3' ){
    palette = palette3;
  }
  if ( key == '4' ){
    palette = palette4;
  }
  if ( key == '5' ){
    palette = palette5;
  }
  if ( key == '6' ){
    palette = palette6;
  }
  if ( key == '7' ){
    palette = palette7;
  }
  if ( key == '8' ){
    palette = palette8;
  }
  if ( key == '9' ){
    palette = palette9;
  }
  
  // grid toggle
  if ( key == 'g' ){
    grid = !grid;
  }
  // twitter noise toggle
  if ( key == 't' ){
    showTweets = !showTweets;
  }
  if ( key == 'd' ){
    if (dayViz == false){
      for (int i = 0; i < 3; i++){
        ArrayList tempArray = new ArrayList();
        String[] lines = loadStrings(keywords[i] + ".csv");
        tempArray = extractDayCount(lines, i);
        dArray.add(new ArrayList(tempArray));
      }
    }else{
      dArray.clear();
    }
    dayViz = !dayViz;
  }
//  if ( key == 'm' ){
//    if ( out.isMuted() ){ out.unmute(); }
//    else{ out.mute(); }
//  }
}

ArrayList extractDayCount(String[] data, int x){
  HashMap dmap = new HashMap();
  ArrayList arr = new ArrayList();
  for (int i = 0; i < data.length; i++) {
    String[] temp = split(data[i], '-');
    String tempStr = temp[1]+"-"+int(temp[2])+"-"+int(temp[3]);
    dmap.put(tempStr, int(temp[0]));
  }
  
  // store each item into an ArrayList
  for (int i = 2007; i < 2013; i++) { // year
    for (int j = 1; j < 13; j++) {    // month
      for (int k = 1; k < 32; k++) {  // day
        int cnt = 0;
        String label = i + "-" + j + "-" + k;
        Integer n = (Integer)dmap.get(label);  // if count exist
        cnt = (n!=null ? n : 0);
        arr.add(new EntityDay(i + "-" + j + "-" + k, i, j, k, cnt));
      }
    }
  }
  return arr;
}
